/*
 * Copyright (c) 2008, Koji Tsukada<tsuka@mobiquitous.com>. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace MobiServer.Devices.Phidget.Control
{
    /// <summary>
    /// Under Developing... Not worked yet.
    /// </summary>
    public partial class PH : Base
    {
        Phidgets.PHSensor phidgetPH= null;

        public PH(Phidgets.Phidget phidget)
            : base(phidget)
        {
            InitializeComponent();
            phidgetPH = (Phidgets.PHSensor)phidget;
            LoadSetting();
        }

        override public bool Start()
        {
            try
            {
                if (!CheckDeviceAttached())
                    return false;

                PrintType();

                phidgetPH.PHChange += new Phidgets.Events.PHChangeEventHandler(OnPHChange);
            }
            catch (Exception ex)
            {
                PrintError(ex.Message);
                return false;
            }
            return true;
        }


        void OnPHChange(object sender, Phidgets.Events.PHChangeEventArgs args)
        { 
            PrintDebug("PH:{0:000.000}, ORP:{1:000.000}", args.PH, phidgetPH.sensor.Potential);
      
            //if (server != null)
            //{
                //server.WriteAllSockets(accel.ToString());
            //}
        }

        private void numericUpDownThreshold_ValueChanged(object sender, EventArgs e)
        {
            if (phidgetPH != null && phidgetPH.Attached)
            {
                phidgetPH.sensor.Sensitivity = (double)numericUpDownThreshold.Value;
            }
        }

        public override void OnServerReadEvent(object sender, MobiServer.ServerEventArgs e)
        {
            try
            {
                if (CheckDeviceType(e.Args))
                {
                }
            }
            catch (Exception ex)
            {
                PrintError(ex.Message);
            }
        }


    }
}

